package com.cf.cs.authentication.exception;

import com.cf.cs.base.common.ErrorCode;
import lombok.Getter;
import lombok.Setter;
import org.springframework.security.core.AuthenticationException;

/**
 * The type Common auth exception.
 *
 * @author xajhuang @163.com
 */
@Getter
@Setter
public class CommonAuthException extends AuthenticationException {
    private final ErrorCode err;

    private final String[] description;

    /**
     * Instantiates a new Common auth exception.
     *
     * @param err to err
     */
    public CommonAuthException(ErrorCode err) {
        super(err.getDescription());
        this.err         = err;
        this.description = new String[] {err.getDescription()};
    }

    /**
     * Instantiates a new Common auth exception.
     *
     * @param err    to err
     * @param readme the readme
     */
    public CommonAuthException(ErrorCode err, String readme) {
        super(readme);
        this.err         = err;
        this.description = new String[] {readme};
    }

    /**
     * Instantiates a new Common auth exception.
     *
     * @param err    to err
     * @param readme the readme
     */
    public CommonAuthException(ErrorCode err, String[] readme) {
        super(err.getDescription());
        this.err         = err;
        this.description = readme;
    }
}
