package com.cf.cs.authentication.security.impl;


import com.cf.cs.authentication.misc.SecurityResponseUtils;
import com.cf.cs.base.common.ErrorCode;
import com.cf.cs.database.service.OperationLogDataBaseService;
import jakarta.annotation.Resource;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.security.access.AccessDeniedException;
import org.springframework.security.web.access.AccessDeniedHandler;
import org.springframework.stereotype.Component;

import java.io.IOException;

/**
 * The type Jwt access denied handler.
 *
 * @author xajhuang @163.com
 */
@Component
public class JwtAccessDeniedHandler implements AccessDeniedHandler {
    @Resource
    private OperationLogDataBaseService optLogDbService;

    @Override
    public void handle(HttpServletRequest request,
                       HttpServletResponse response,
                       AccessDeniedException accessDeniedException) throws IOException {
        response.setStatus(HttpServletResponse.SC_FORBIDDEN);
        SecurityResponseUtils.authenticationResponse(request, response, ErrorCode.ERR_PERMISSION, accessDeniedException.getMessage(),
                                                     optLogDbService);
    }
}
