package com.cf.cs.authentication.service;


import com.cf.cs.base.pojo.po.JwtCache;

/**
 * The interface Account jwt cache service.
 *
 * @author xajhuang @163.com
 */
public interface AccountJwtCacheService {
    /**
     * Gets account jwt cache.
     *
     * @param userId the user id
     * @return the account jwt cache
     */
    JwtCache getAccountJwtCache(String userId);

    /**
     * Create account jwt cache.
     *
     * @param userId the user id
     * @param jwt    the jwt
     * @return the jwt cache
     */
    JwtCache createAccountJwtCache(String userId, String jwt);

    /**
     * Delete account jwt cache.
     *
     * @param userId the user id
     */
    void deleteAccountJwtCache(String userId);
}
