package com.cf.cs.authentication.service.impl;

import com.cf.cs.authentication.service.AccountJwtCacheService;
import com.cf.cs.base.pojo.po.JwtCache;
import lombok.extern.slf4j.Slf4j;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.CachePut;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

/**
 * The type Account jwt cache service.
 *
 * @author xajhuang @163.com
 */
@Service
@Slf4j
public class AccountJwtCacheServiceImpl implements AccountJwtCacheService {
    @Override
    @Cacheable(value = "JWT_CACHE", key = "'user'+#userId", sync = true)
    public JwtCache getAccountJwtCache(String userId) {
        return null;
    }

    @Override
    @CachePut(value = "JWT_CACHE", key = "'user'+#userId")
    public JwtCache createAccountJwtCache(String userId, String jwt) {
        return JwtCache.builder().addTimestamp(System.currentTimeMillis()).jwt(jwt).uId(userId).build();
    }

    @Override
    @CacheEvict(value = "JWT_CACHE", key = "'user'+#userId")
    public void deleteAccountJwtCache(String userId) {
        // cache automatic manager
    }
}
