package com.cf.cs.base.annotation;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * The interface Operation log annotation.
 *
 * @author xajhuang @163.com
 */
@Target({ElementType.PARAMETER, ElementType.METHOD}) // 注解放置的目标位置,PARAMETER: 可用在参数上  METHOD：可用在方法级别上
@Retention(RetentionPolicy.RUNTIME)    // 指明修饰的注解的生存周期  RUNTIME：运行级别保留
@Documented
@SuppressWarnings("java:S100")
public @interface OperationLogAnnotation {
    /**
     * Operation module string.
     *
     * @return the string
     */
    String OperationModule() default ""; // 操作模块

    /**
     * Operation type string.
     *
     * @return the string
     */
    String OperationType() default "";  // 操作类型

    /**
     * Operation desc string.
     *
     * @return the string
     */
    String OperationDesc() default "";  // 操作说明
}
