package com.cf.cs.base.common;

/**
 * The type Const value.
 *
 * @author xajhuang @163.com
 */
public class ConstValue {
    private ConstValue() {
        throw new AssertionError("Instantiating utility class.");
    }

    /**
     * The constant UN_EXPECT_REGEX_CHARS.
     */
    public static final String UN_EXPECT_REGEX_CHARS = "^((?!(--|\\s|\\*|%|\\+|'|;])).)*$";


    /**
     * The constant STRING_HTTP_AUTH_HEAD.
     */
    public static final String STRING_HTTP_AUTH_HEAD = "Bearer ";
    public static final long MS_OF_SECONDS = 1000L;
    public static final long SECOND_OF_MINUTE = 60;

    public static final int MAX_IPV4_LEN = 15;

    /**
     * The constant IP_ADDR_REG.
     */
    public static final String IP_ADDR_REG = "^((25[0-5]|2[0-4]\\d|[01]?\\d\\d?)\\.){3}" +
            "(25[0-5]|2[0-4]\\d|[01]?\\d\\d?)$|^" +
            "([\\da-fA-F]{1,4}:){6}((25[0-5]|2[0-4]\\d|[01]?\\d\\d?)\\.){3}(25[0-5]|2[0-4]\\d|[01]?\\d\\d?)$|^::" +
            "([\\da-fA-F]{1,4}:){0,4}((25[0-5]|2[0-4]\\d|[01]?\\d\\d?)\\.){3}(25[0-5]|2[0-4]\\d|[01]?\\d\\d?)$|^" +
            "([\\da-fA-F]{1,4}:):([\\da-fA-F]{1,4}:){0,3}((25[0-5]|2[0-4]\\d|[01]?\\d\\d?)\\.){3}" +
            "(25[0-5]|2[0-4]\\d|[01]?\\d\\d?)$|^([\\da-fA-F]{1,4}:){2}:([\\da-fA-F]{1,4}:){0,2}(" +
            "(25[0-5]|2[0-4]\\d|[01]?\\d\\d?)\\.){3}(25[0-5]|2[0-4]\\d|[01]?\\d\\d?)$|^([\\da-fA-F]{1,4}:){3}:" +
            "([\\da-fA-F]{1,4}:){0,1}((25[0-5]|2[0-4]\\d|[01]?\\d\\d?)\\.){3}(25[0-5]|2[0-4]\\d|[01]?\\d\\d?)$|^" +
            "([\\da-fA-F]{1,4}:){4}:((25[0-5]|2[0-4]\\d|[01]?\\d\\d?)\\.){3}(25[0-5]|2[0-4]\\d|[01]?\\d\\d?)$|^" +
            "([\\da-fA-F]{1,4}:){7}[\\da-fA-F]{1,4}$|^:((:[\\da-fA-F]{1,4}){1,6}|:)$|^[\\da-fA-F]{1,4}:((:[\\da-fA-F]{1," +
            "4}){1,5}|:)$|^([\\da-fA-F]{1,4}:){2}((:[\\da-fA-F]{1,4}){1,4}|:)$|^([\\da-fA-F]{1,4}:){3}((:[\\da-fA-F]{1," +
            "4}){1,3}|:)$|^([\\da-fA-F]{1,4}:){4}((:[\\da-fA-F]{1,4}){1,2}|:)$|^([\\da-fA-F]{1,4}:){5}:([\\da-fA-F]{1,4})" +
            "?$|^([\\da-fA-F]{1,4}:){6}:$";

    /**
     * The type Protocol.
     *
     * @author xajhuang @163.com
     */
    public static class Protocol {
        /**
         * The constant VERSION.
         */
        public static final int VERSION = 1;

        private Protocol() {
            throw new AssertionError("Instantiating utility class.");
        }
    }
}
