package com.cf.cs.database.pojo.entity;

import com.mybatisflex.annotation.Column;
import com.mybatisflex.annotation.Id;
import com.mybatisflex.annotation.KeyType;
import com.mybatisflex.annotation.RelationOneToMany;
import com.mybatisflex.annotation.Table;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.sql.Timestamp;
import java.util.List;

/**
 * 字典类型表 实体类。
 *
 * @author mybatis -flex-helper automatic generation
 * @since 1.0
 */
@Data
@Schema(name = "字典类型表")
@Table(value = "sys_dict_type")
public class DictType {

    /**
     * 字典主键
     */
    @Schema(description = "字典主键")
    @Id(keyType = KeyType.Auto)
    private Long id;

    /**
     * 字典名称
     */
    @Schema(description = "字典名称")
    @Column(value = "dict_name")
    private String dictName;

    /**
     * 字典类型
     */
    @Schema(description = "字典类型")
    @Column(value = "dict_type")
    private String dictTypeName;

    /**
     * 创建者
     */
    @Schema(description = "创建者")
    @Column(value = "create_by")
    private String createBy;

    /**
     * 创建时间
     */
    @Schema(description = "创建时间")
    @Column(value = "create_time")
    private Timestamp createTime;

    /**
     * 更新者
     */
    @Schema(description = "更新者")
    @Column(value = "update_by")
    private String updateBy;

    /**
     * 更新时间
     */
    @Schema(description = "更新时间")
    @Column(value = "update_time")
    private Timestamp updateTime;

    /**
     * 备注
     */
    @Schema(description = "备注")
    @Column(value = "remark")
    private String remark;

    @Schema(description = "逻辑删除标记")
    @Column(value = "delete_time", isLogicDelete = true)
    private Timestamp deleteTime;

    @RelationOneToMany(selfField = "id", targetField = "typeId", targetTable = "sys_dict_data")
    @Column(ignore = true)
    private List<DictData> dictDataList;
}
