package com.cf.cs.database.pojo.entity;

import com.cf.cs.database.config.UuidKeyGenerator;
import com.mybatisflex.annotation.Column;
import com.mybatisflex.annotation.Id;
import com.mybatisflex.annotation.KeyType;
import com.mybatisflex.annotation.Table;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.sql.Timestamp;

/**
 * 系统操作日志 实体类。
 *
 * @author mybatis -flex-helper automatic generation
 * @since 1.0
 */
@Data
@Schema(name = "系统操作日志")
@Table(value = "sys_operation_log")
public class OperationLog {
    /**
     * id
     */
    @Schema(description = "id")
    @Id(keyType = KeyType.Auto)
    private Long id;

    @Schema(description = "uid")
    @Id(keyType = KeyType.Generator, value = UuidKeyGenerator.COMMON_UUID)
    private String uid;

    /**
     * 操作模块
     */
    @Schema(description = "操作模块")
    @Column(value = "module")
    private String module;

    /**
     * 操作类型
     */
    @Schema(description = "操作类型")
    @Column(value = "operation_type")
    private String operationType;

    /**
     * 操作状态
     */
    @Schema(description = "操作状态")
    @Column(value = "operation_status")
    private String operationStatus;

    /**
     * 操作说明
     */
    @Schema(description = "操作说明")
    @Column(value = "description")
    private String description;

    /**
     * 请求来源 IP 地址
     */
    @Schema(description = "请求来源 IP 地址")
    @Column(value = "request_ip")
    private String requestIp;

    /**
     * 请求接口
     */
    @Schema(description = "请求接口")
    @Column(value = "call_function")
    private String callFunction;

    /**
     * HTTP 请求类型
     */
    @Schema(description = "HTTP 请求类型")
    @Column(value = "http_method")
    private String httpMethod;

    /**
     * 请求URI
     */
    @Schema(description = "请求URI")
    @Column(value = "http_path")
    private String httpPath;

    /**
     * 响应时间(ms)
     */
    @Schema(description = "响应时间(ms)")
    @Column(value = "expend_time")
    private Long expendTime;

    /**
     * 传输延时(ms)
     */
    @Schema(description = "传输延时(ms)")
    @Column(value = "transmit_delay")
    private Long transmitDelay;

    /**
     * 操作用户id
     */
    @Schema(description = "操作用户id")
    @Column(value = "user_id")
    private Long userId;

    /**
     * HTTP 请求头所有参数
     */
    @Schema(description = "HTTP 请求头所有参数")
    @Column(value = "request_headers")
    private String requestHeaders;

    /**
     * 操作请求参数
     */
    @Schema(description = "操作请求参数")
    @Column(value = "request")
    private String request;

    /**
     * 操作返回结果
     */
    @Schema(description = "操作返回结果")
    @Column(value = "result")
    private String result;

    /**
     * 操作时间
     */
    @Schema(description = "操作时间")
    @Column(value = "operation_time")
    private Timestamp operationTime;
}
