package com.cf.cs.database.pojo.entity;

import com.cf.cs.database.config.UuidKeyGenerator;
import com.mybatisflex.annotation.Column;
import com.mybatisflex.annotation.Id;
import com.mybatisflex.annotation.KeyType;
import com.mybatisflex.annotation.RelationOneToOne;
import com.mybatisflex.annotation.Table;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

/**
 * 实体类。
 *
 * @author mybatis -flex-helper automatic generation
 * @since 1.0
 */
@Data
@Schema(name = "$table.comment")
@Table(value = "rbac_resource_data")
public class ResourceData {

    /**
     * id
     */
    @Schema(description = "id")
    @Id(keyType = KeyType.Auto)
    private Long id;

    @Schema(description = "uid")
    @Id(keyType = KeyType.Generator, value = UuidKeyGenerator.COMMON_UUID)
    private String uid;

    /**
     * 资源URL
     */
    @Schema(description = "资源URL")
    @Column(value = "path")
    private String path;

    /**
     * 资源名称
     */
    @Schema(description = "资源名称")
    @Column(value = "name")
    private String name;

    /**
     * 资源访问 HTTP 方法 GET/POST/DELETE/...
     */
    @Schema(description = "资源访问 HTTP 方法 GET/POST/DELETE/...")
    @Column(value = "http_method")
    private String httpMethod;

    @Schema(description = "资源类型")
    @Column(value = "type_id")
    private Integer typeId;

    @RelationOneToOne(selfField = "typeId", targetField = "typeId", targetTable = "rbac_resource_type")
    @Column(ignore = true)
    private ResourceType resType;
}
