package com.cf.cs.database.pojo.entity;

import com.cf.cs.database.config.UuidKeyGenerator;
import com.mybatisflex.annotation.Column;
import com.mybatisflex.annotation.Id;
import com.mybatisflex.annotation.KeyType;
import com.mybatisflex.annotation.RelationOneToOne;
import com.mybatisflex.annotation.Table;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.sql.Timestamp;

/**
 * 用户表(User)表实体类
 *
 * @author makejava @163.com
 * @since 2023 -12-19 15:14:43
 */
@Data
@Schema(name = "User", description = "用户表")
@Table("rbac_user")
public class User {
    /**
     * id
     */
    @Schema(description = "id")
    @Id(keyType = KeyType.Auto)
    private Long      id;

    @Schema(description = "uid")
    @Id(keyType = KeyType.Generator, value = UuidKeyGenerator.COMMON_UUID)
    private String uid;

    /**
     * 创建时间
     */
    @Schema(description = "创建时间")
    @Column(value = "created_time")
    private Timestamp createdTime;
    /**
     * 创建用户
     */
    @Schema(description = "创建用户")
    @Column(value = "gender")
    private Long      gender;
    /**
     * 用户名
     */
    @Schema(description = "用户名")
    @Column(value = "username")
    private String    username;

    @Schema(description = "用户权限ID")
    @Column(value = "role_id")
    private Long roleId;

    @Schema(description = "逻辑删除标记")
    @Column(value = "delete_time", isLogicDelete = true)
    private Timestamp deleteTime;

    @RelationOneToOne(selfField = "id", targetField = "userId")
    @Column(ignore = true)
    private UserCredential userCredential;
}

