package com.cf.cs.database.pojo.po;

import com.houkunlin.system.dict.starter.json.DictText;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Builder;
import lombok.Data;

import java.sql.Timestamp;

/**
 * The type User info.
 *
 * @author xajhuang @163.com
 */
@Schema(name = "用户信息")
@Data
@Builder
public class UserInfo {
    @Schema(description = "用户uid")
    private String uid;

    @Schema(description = "创建时间")
    private Timestamp createdTime;

    @Schema(description = "创建用户")
    private Long gender;

    @Schema(description = "用户名")
    private String username;

    @Schema(description = "用户组ID")
    @DictText(value = "sys_role_group", fieldName = "roleIdName")
    private Long roleId;

    @Schema(description = "当前状态: 0-->正常，1-->锁定，2-->禁用,3-->删除")
    @DictText(value = "CommonStatus", fieldName = "userStatusName")
    private Integer userStatus;
}
