package com.cf.cs.database.service.impl;


import com.cf.cs.database.mapper.RoleMapper;
import com.cf.cs.database.mapper.RoleResourceMapper;
import com.cf.cs.database.pojo.entity.Role;
import com.cf.cs.database.pojo.entity.RoleResource;
import com.cf.cs.database.service.RoleResourceService;
import com.mybatisflex.core.query.QueryWrapper;
import com.mybatisflex.spring.service.impl.ServiceImpl;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

import static com.cf.cs.database.pojo.entity.table.RoleResourceTableDef.ROLE_RESOURCE;
import static com.cf.cs.database.pojo.entity.table.RoleTableDef.ROLE;

/**
 * 权限资源 服务层实现。
 *
 * @author mybatis -flex-helper automatic generation
 * @since 1.0
 */
@Service
public class RoleResourceServiceImpl extends ServiceImpl<RoleResourceMapper, RoleResource> implements RoleResourceService {
    @Resource
    private RoleMapper roleMapper;

    @Resource
    private RoleResourceMapper roleResourceMapper;

    @Override
    public List<RoleResource> getRoleResourceByRoleName(String roleName) {
        QueryWrapper wrapper = QueryWrapper.create().from(ROLE).select().where(ROLE.NAME.eq(roleName));
        Role         role    = roleMapper.selectOneByQuery(wrapper);

        if (role == null) {
            return new ArrayList<>();
        } else {
            wrapper = QueryWrapper.create().from(ROLE_RESOURCE).select();
            return roleResourceMapper.selectListWithRelationsByQuery(wrapper);
        }
    }

    @Override
    public List<RoleResource> getRoleResourceByRoleId(Long roleId) {
        QueryWrapper wrapper = QueryWrapper.create().from(ROLE).select().where(ROLE.ID.eq(roleId));
        Role         role    = roleMapper.selectOneByQuery(wrapper);

        if (role == null) {
            return new ArrayList<>();
        } else {
            wrapper = QueryWrapper.create().from(ROLE_RESOURCE).select().where(ROLE_RESOURCE.ROLE_ID.eq(roleId));
            return roleResourceMapper.selectListWithRelationsByQuery(wrapper);
        }
    }
}