package com.cf.cs.integratetest.controller;

import com.cf.cs.integratetest.common.TestBaseAuthentication;
import com.cf.cs.protocol.pojo.vo.VersionResp;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.test.context.junit.jupiter.SpringExtension;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestMethod;

@ExtendWith({SpringExtension.class})
@Transactional
@SuppressWarnings("java:S5786")
public class CommonFrameworkApiTest extends TestBaseAuthentication {
    @Test
    @DisplayName("获取版本信息")
    void testGetVersion() throws Exception {
        VersionResp resp = (VersionResp) performanceRestful(RequestMethod.GET, null, "/api/version", new Class[] {VersionResp.class});
        AssertValidCommonResp(resp);
        Assertions.assertNotNull(resp.getVersion());

        Assertions.assertNotNull(resp.getVersion().getTagName());
        AssertValidString(resp.getVersion().getCommitId());
        AssertValidString(resp.getVersion().getCommitDescribe());
        AssertValidString(resp.getVersion().getCommitTime());
        AssertValidString(resp.getVersion().getBuildTime());
        AssertValidString(resp.getVersion().getGitBranch());
    }

    @Test
    @DisplayName("获取版本信息(POST)")
    void testGetVersionV2() throws Exception {
        VersionResp resp = (VersionResp) performanceRestful(RequestMethod.POST, null, "/api/version", new Class[] {VersionResp.class});
        AssertValidCommonResp(resp);
        Assertions.assertNotNull(resp.getVersion());

        Assertions.assertNotNull(resp.getVersion().getTagName());
        AssertValidString(resp.getVersion().getCommitId());
        AssertValidString(resp.getVersion().getCommitDescribe());
        AssertValidString(resp.getVersion().getCommitTime());
        AssertValidString(resp.getVersion().getBuildTime());
        AssertValidString(resp.getVersion().getGitBranch());
    }
}
