package com.cf.cs.protocol.pojo.dto;

import com.cf.cs.protocol.pojo.po.DictDetails;
import com.cf.cs.protocol.validation.group.ValidGroups;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.v3.oas.annotations.media.Schema;
import jakarta.validation.Valid;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Size;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * The type Add dict content req.
 *
 * @author xajhuang @163.com
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "AddDictContentReq", description = "新增用户字典内容请求参数")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class AddDictContentReq {
    @NotBlank(message = "dictTpe 字典名称不能为空", groups = ValidGroups.DictReqValid.class)
    private String dictName;

    @NotNull(message = "dictContent 字典内容值不能为 NULL", groups = ValidGroups.DictReqValid.class)
    @Size(min = 1, max = 100, message = "字典内容至少需要指定 1 个，最多只能指定 100 个", groups = ValidGroups.DictReqValid.class)
    private List<@Valid DictDetails> dictContent;
}
