package com.cf.cs.protocol.pojo.dto;


import com.cf.cs.protocol.validation.group.ValidGroups;
import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Pattern;
import jakarta.validation.constraints.Size;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * The type Id array req.
 *
 * @author xajhuang @163.com
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
public class IdArrayReq {
    /**
     * The Ids.
     */
    @NotNull(message = "ids 不能为 NULL", groups = ValidGroups.UserIdReqValid.class)
    @Size(min = 1, max = 100, message = "ids 元素个数最小为1， 最大为100", groups = ValidGroups.UserIdReqValid.class)
    List<@NotBlank(message = "guid 不能为空", groups = ValidGroups.UserIdReqValid.class)
    @Pattern(regexp = "^[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$",
             message = "uid 必须为符号UUID规范(xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx)的字符串", groups = ValidGroups.UserIdReqValid.class)
            String> ids;
}
