package com.cf.cs.protocol.pojo.dto;

import com.cf.cs.protocol.validation.group.ValidGroups;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.v3.oas.annotations.media.Schema;
import jakarta.validation.constraints.NotEmpty;
import jakarta.validation.constraints.Size;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * The type Operation log details req.
 *
 * @author xajhuang @163.com
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
@Schema(name = "OperationLogDetailsReq", description = "操作日志详细请求参数")
public class OperationLogDetailsReq {
    @Schema(description = "操作日志ID")
    @NotEmpty(message = "操作日志ID不能为空", groups = ValidGroups.OperationLogReqValid.class)
    @Size(message = "操作日志ID至少需要指定 1 个，最多只能指定 100 个", min = 1, max = 100, groups = ValidGroups.OperationLogReqValid.class)
    private List<Long> operationIds;
}
