package com.cf.cs.protocol.pojo.dto;

import com.cf.cs.protocol.validation.group.ValidGroups;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.v3.oas.annotations.media.Schema;
import jakarta.validation.constraints.NotNull;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * The type Remove dict req.
 *
 * @author xajhuang @163.com
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
@Schema(name = "RemoveDictReq", description = "删除用户字典请求参数")
public class RemoveDictReq {
    @Schema(description = "字典名，用于标识各个不同的字典")
    @NotNull(message = "dictName 字典名不能为NULL", groups = ValidGroups.DictReqValid.class)
    private String dictName;
}
