package com.cf.cs.protocol.pojo.po;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * The type Dict content.
 *
 * @author xajhuang @163.com
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@JsonPropertyOrder({"dictId", "dictName", "dictAlias", "dictRemark", "children", "status", "message"})
@JsonInclude(JsonInclude.Include.NON_NULL)
public class DictContent extends BaseRespStatus {
    private Long              dictId;
    private String            dictName;
    private String            dictAlias;
    private String            dictRemark;
    private List<DictDetails> children;
}
