package com.cf.cs.protocol.pojo.vo;

import com.cf.cs.database.pojo.entity.Role;
import com.cf.cs.protocol.pojo.po.BaseRespStatus;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * The type Get role resp.
 *
 * @author xajhuang @163.com
 */
@Schema(name = "用户组详细信息")
@EqualsAndHashCode(callSuper = true)
@Data
@Builder
@JsonPropertyOrder({"roles", "status", "message"})
@AllArgsConstructor
@NoArgsConstructor
public class GetRoleResp extends BaseRespStatus {
    @Schema(description = "当前用户组")
    private List<Role> roles;
}
