package com.cf.cs.protocol.validation.valids.impl;

import com.cf.cs.protocol.validation.valids.ValidHttpMethod;
import jakarta.validation.ConstraintValidator;
import jakarta.validation.ConstraintValidatorContext;
import org.springframework.web.bind.annotation.RequestMethod;

import java.util.List;

/**
 * The type Valid http method.
 *
 * @author xajhuang @163.com
 */
public class ValidHttpMethodImpl implements ConstraintValidator<ValidHttpMethod, List<String>> {
    @Override
    public void initialize(ValidHttpMethod constraintAnnotation) {

        ConstraintValidator.super.initialize(constraintAnnotation);
    }

    @Override
    public boolean isValid(List<String> strings, ConstraintValidatorContext context) {
        StringBuilder errMsg = new StringBuilder();

        strings.forEach(k -> {
            if (RequestMethod.resolve(k.toUpperCase()) == null) {
                errMsg.append("[")
                      .append(k)
                      .append("]: 不是合法的 HTTP 请求方法");
            }
        });

        if (!errMsg.isEmpty()) {
            context.disableDefaultConstraintViolation();
            context.buildConstraintViolationWithTemplate(errMsg.toString()).addConstraintViolation();
            return false;
        }
        return true;
    }
}
