package com.cf.cs.restful.configure;

import jakarta.annotation.PostConstruct;
import lombok.Getter;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

/**
 * The type Project git version info.
 *
 * @author xajhuang @163.com
 */
@Getter
@Setter
@Component
@Slf4j
@PropertySource("classpath:git.properties")
public class ProjectGitVersionInfo {
    @Value("${git.commit.id}")
    private String commitId;
    @Value("${git.commit.id.describe}")
    private String commitDescribe;
    @Value("${git.commit.time}")
    private String commitTime;
    @Value("${git.closest.tag.name}")
    private String tagName;
    @Value("${git.build.time}")
    private String buildTime;

    @Value("${git.branch}")
    private String gitBranch;

    @PostConstruct
    private void initGlobalValue() {
        String version = buildTime + " " + commitId + " " + gitBranch + " " + tagName;
        log.info("Version: {}", version.trim());
    }
}
