package com.cf.cs.restful.service.impl;


import com.cf.cs.restful.pojo.mapper.IObjectConvert;
import com.cf.cs.protocol.pojo.po.HwInfo;
import com.cf.cs.protocol.pojo.po.ProcessorInfo;
import com.cf.cs.restful.service.SystemInfoService;
import org.springframework.stereotype.Service;
import oshi.SystemInfo;
import oshi.hardware.CentralProcessor;
import oshi.hardware.ComputerSystem;

/**
 * The type System info service.
 *
 * @author xajhuang @163.com
 */
@Service
public class SystemInfoServiceImpl implements SystemInfoService {
    private final SystemInfo si = new SystemInfo();

    @Override
    public String getOsName() {
        return String.valueOf(si.getOperatingSystem());
    }

    @Override
    public long getOsBootTimeStamp() {
        return si.getOperatingSystem().getSystemBootTime() * 1000L;
    }

    @Override
    public ProcessorInfo getProcessInfo() {
        CentralProcessor proc = si.getHardware().getProcessor();
        return IObjectConvert.INSTANCE.toProcessorInfo(proc, proc.getProcessorIdentifier());
    }

    @Override
    public HwInfo getHardwareInfo() {
        ComputerSystem cs = si.getHardware().getComputerSystem();
        return IObjectConvert.INSTANCE.toHwInfo(cs);
    }
}
